/*
  KEYS.H
  Main header file for keyboard scancodes


  Copyright (c) 1994 by Borland International
  All Rights Reserved

  This source code is hereby released into the public domain.
  Written by Jeffrey J. Peters

*/

#ifndef __KEYS_H
#define __KEYS_H

const bits16 K_DOWN           = 0x5000;    // down
const bits16 K_UP             = 0x4800;    // up
const bits16 K_HOME           = 0x4700;    // home
const bits16 K_END            = 0x4F00;    // end
const bits16 K_PGUP           = 0x4900;    // pgUp
const bits16 K_CTRL_PGUP      = 0x8400;    // Ctrl-pgUp
const bits16 K_PGDOWN         = 0x5100;    // pgDown
const bits16 K_CTRL_PGDOWN    = 0x7600;    // Ctrl-pgDown
const bits16 K_RIGHT          = 0x4D00;    // right
const bits16 K_LEFT           = 0x4B00;    // left
const bits16 K_CTRL_LEFT      = 0x7300;    // Ctrl-Left
const bits16 K_CTRL_RIGHT     = 0x7400;    // Ctrl-Right
const bits16 K_CTRL_HOME      = 0x7700;    // Ctrl-home
const bits16 K_CTRL_END       = 0x7500;    // Ctrl-end
const bits16 K_ALT_X          = 0x2D00;    // Alt-X
const bits16 K_CTRL_F5        = 0x6200;    // Ctrl-F5
const bits16 K_F5             = 0x3F00;    // F5
const bits16 K_F1             = 0x3B00;    // F1
const bits16 K_CTRL_F4        = 0x6100;    // Ctrl-F4
const bits16 K_ALT_F3         = 0x6A00;    // Alt-F3

const bits16 K_SHIFT_UP       = 0x4838;    // shift-up
const bits16 K_SHIFT_DOWN     = 0x5032;    // shift-down
const bits16 K_SHIFT_RIGHT    = 0x4B34;    // shift-right
const bits16 K_SHIFT_LEFT     = 0x4D36;    // shift-left
const bits16 K_SHIFT_PGUP     = 0x4939;    // shift-pgUp
const bits16 K_SHIFT_PGDOWN   = 0x5133;    // shift-pgDown


const bits16 K_CTRL_D         = 0x2004;    // Ctrl-D
const bits16 K_CTRL_G         = 0x2207;    // Ctrl-G
const bits16 K_CTRL_L         = 0x260C;    // Ctrl-L
const bits16 K_CTRL_N         = 0x310E;    // Ctrl-N
const bits16 K_CTRL_S         = 0x1F13;    // Ctrl-S


const bits16 K_ENTER          = 0x1C0D;    // <Enter>
const bits16 K_CTRL_ENTER     = 0x1C0A;    // Ctrl-<Enter>
const bits16 K_ESC            = 0x011B;    // <Escape>
const bits16 K_BS             = 0x0E08;    // <BackSpace>
const bits16 K_DEL            = 0x5300;    // <Delete>

#endif // __KEYS_H