/*
  UISVU.CPP
  Main source file for class UISelView


  Copyright (c) 1994 by Borland International
  All Rights Reserved

  This source code is hereby released into the public domain.
  Written by Jeffrey J. Peters

*/

#include <dir.h>
#include <dos.h>
#include "uiclass.h"


UISelView::UISelView (bits16 s) : sel (s), UIWindow (UIRect(2,8,80,13)," Selector View ")
{
  uiFlags |= UIFNoScroll;
  uiFlags |= UIFNoZoom;
  uiFlags |= UIFNoStretch;
  uiFlags |= UIFNoCursorFix;
}

char *UISelView::CrackRights (bits08 r)
{
  static char buf[81];
  buf[0] = 0;

  if (r & 0x08)
  {
    strcat (buf, "Code R/O ");
  }
  else
  {
    strcat (buf, "Data ");
    if (r & 0x02)
      strcat (buf, "R/W ");
    else
      strcat (buf, "R/O ");

    if (r & 0x04)
      strcat (buf, "Dwn ");
    else
      strcat (buf, "Up ");
  }
  if (r & 0x01)
    strcat (buf, "Acc ");
  else
    strcat (buf, "!Acc ");

  if (r & 0x80)
    strcat (buf, "Pres ");
  else
    strcat (buf, "!Pres ");

  return buf;
}

static char *near DtoS (WORD d)   // Date to String
{
  static char buf[11];
  struct tempdate
  {
    WORD day:5;
    WORD month:4;
    WORD years:7;
  } *t = (struct tempdate*) &d;

  sprintf (buf, "%2u/%02u/%04u", t->month, t->day, t->years+1980);
  return buf;
}

static char *near TtoS (WORD d)   // Time to String
{
  static char buf[11];
  struct temptime
  {
    WORD res:5;
    WORD min:6;
    WORD hour:5;
  } *t = (struct temptime*) &d;

  sprintf (buf, "%2u:%02u", t->hour, t->min);
  return buf;
}

#pragma argsused
int UISelView::Update (int dsp)
{
  char *mod;
  char *strRights;
  char *p;
  struct ffblk ff;

  if (IsValidSel (sel))
  {
    limit  = GetLimit  (sel);
    base   = GetBase   (sel);
    rights = GetRights (sel);
    mod    = GetMod    (sel);
    strRights = CrackRights (rights);
  }
  else
  {
    limit = base = rights = 0;
    mod = "<Invalid>";
    strRights = "";
  }

  p = strchr (mod, ':');
  if (p)
  {
    p++;
    if (findfirst (p, &ff, 0)!=0)
      p = NULL;
  }

  gotoxy (1,1);
  cprintf ("%04X Base:[%08lX] Limit:(%08lX) Rights:<%02X> %s",
           sel, base, limit, rights, strRights);
  gotoxy (1,2);
  cputs (mod);
  if (p)
  {
    gotoxy (1,3);
    cprintf ("(%07ld bytes) ", ff.ff_fsize);
    cprintf ("%s ", DtoS (ff.ff_fdate));
    cprintf ("%s ", TtoS (ff.ff_ftime));
  }

  return 1;
}

int UISelView::begin (void)
{
  bits16 key;
  int out = 0;

  SetLineType (1);
  DrawBox (uiFlags, LIGHTCYAN|_BLUE, WHITE|_BLUE);

  while (!out)
  {
    key = getch ();
    if (key == K_ESC)
      out = 1;
    if (key == K_F1)
    {
          UIMsgBox (
          " <Esc>         - exit to previous window\r\n"
          " <Ctrl-F5>     - move/re-size the window\r\n"
          "This is a list of the attributes of the current selector.\r\n"
          "The base, limit, and flags are listed out.\r\n"
          #ifdef __DPMI16__
          "If a module is associated with this selector, then the\r\n"
          "module information is also listed\r\n"
          #endif
          ,  " Selector Window Help " ,6, 70);
    }
  }
  return 1;
}
